//+------------------------------------------------------------------+
//|                                      ClassificaForzaRelativa.mq4 |
//|                                                      Autotrading |
//|                                              www.metatrading.net |
//+------------------------------------------------------------------+
#property copyright "Autotrading"
#property link      "www.metatrading.net"
#property show_inputs

//Matrice per determinare i cross che ci interessano
string insiemeCross[] = {"EURUSD", "EURGBP", "EURJPY", "EURCHF"};

//Secondi per cui effettuare il refresh dei dati
extern int numeroSecondi = 5;

int start()
  {
   while(!IsStopped())
   {
      Comment(getClassifica());
      Sleep(numeroSecondi * 1000);
   }
   Comment("Esecuzione script terminata.");
   
   return(0);
  }

//Ottiene il prezzo di apertura alla mezzanotte del giorno corrente  
double getCloseAtMidnight(string cross)
{     
   return(iClose(cross, PERIOD_H1, TimeHour(TimeCurrent())));
}

//Calcola il guadagno in termini percentuali di un cross alla mezzanotte
double calcolaGain(string cross)
{
   double valoreAmezzanotte = getCloseAtMidnight(cross);
   double valoreAttuale = iClose(cross, PERIOD_H1, 0);
   if(valoreAttuale == valoreAmezzanotte)return(0);
   double percentuale = (valoreAttuale - valoreAmezzanotte) / valoreAmezzanotte;
   return(percentuale * 100);
}

//Dati una matrice di valori decimali ed un valore da cercare questa funzione
//la posizione dell'indice in cui  stato trovato il valore
int trovaIndiceMatrice(double matrice[], double valore)
{
   int ciclo;
   int count=ArraySize(matrice) - 1;
   for(ciclo=0;ciclo<=count;ciclo++)
   {
      if(valore==matrice[ciclo]) return(ciclo);
   } 
   return(-1);
}

string getClassifica()
{
   int numeroArray = ArraySize(insiemeCross);
   //Variabili temporanee
   string valute[];
   double valori[];
   double tempValori[];
   int classifica[];
   
   //Ridimensionamento matrici
   ArrayResize(valute, numeroArray + 1);
   ArrayResize(valori, numeroArray + 1);
   ArrayResize(tempValori, numeroArray + 1);
   ArrayResize(classifica, numeroArray + 1);
   
   //Eseguiamo un ciclo per valorizzare le matrici con i nomi delle valute
   //e con il valore di variazione dalla mezzanotte
   int ciclo;
   int count=numeroArray - 1;
   for(ciclo=0;ciclo<=count;ciclo++)
   {
      valute[ciclo] = StringSubstr(insiemeCross[ciclo], 3, 3);
      valori[ciclo] = calcolaGain(insiemeCross[ciclo]);
   }
   
   //Aggiungiamo alle matrici la valuta euro
   //La variazione dell'euro su se stesso  sempre 0
   valute[numeroArray] = "EUR";
   valori[numeroArray] = 0;
   
   //Copiamo i valori in una matrice temporanea su cui
   //effettueremo un ordinamento
   ArrayCopy(tempValori, valori);
   ArraySort(tempValori);
   
   //Utilizziamo la funzione trovaIndiceMatrice per
   //sapere dove si trovano i valori originali
   count=numeroArray;
   for(ciclo=0;ciclo<=count;ciclo++)
   {
      classifica[ciclo] = trovaIndiceMatrice(valori, tempValori[ciclo]);
   }
   
   string result;
   int indiceAttivo;
   for(ciclo=0;ciclo<=count;ciclo++)
   {
      indiceAttivo = classifica[ciclo];
      result = result + valute[indiceAttivo] + "  " + DoubleToStr(valori[indiceAttivo], 2) + "\n";
   }
           
   return (result);
}